/*
	Program that finds vertex of triangles in an image

	Sergio Herrera July/2018
*/

#include "find_Triangles.h"
#include "follow.h"



double* find_object ( MATRIX *IMG1 )
{

	printf(" HOLAMUNDO!!! \n\n\n");
	return NULL;
}


int find_TRIANGLES( MATRIX *IN , POINT* T1, POINT* T2) 
{
	//printf("Finding triangles now... \n");

	MATRIX *IMG, *FIL;

	if ( IN ==NULL ) {
		fprintf( stderr, "ERROR in IMG \n" );
		return -1;
	}
	if ( IN->type != 5 ) {
		fprintf( stderr, "ERROR Bad format. Image must be in b/w\n");
		return -1;
	}
	
	//2 - Smoothing (2 Pass)
		int **fil;
		FIL = matrix_allocate( 3, 3, sizeof( int ) );
		if ( FIL==NULL ) {
			fprintf( stderr, "ERROR allocating memory\n" );
			return -1;
		}
		//Smooth Window
		fil = (int **)FIL->ptr;
		fil[0][0] = 1; fil[0][1] = 1; fil[0][2] = 1;
		fil[1][0] = 1; fil[1][1] = 1; fil[1][2] = 1;
		fil[2][0] = 1; fil[2][1] = 1; fil[2][2] = 1;

		IMG = convolution( IN, FIL, 9 );	//1st Pass
				write_pnm( IMG, "1_convol1.pgm" );

		//memcpy( IN, IMG, sizeof(MATRIX) );
		//IMG = convolution( IN, FIL, 9 );	//2nd Pass
				//write_pnm( IMG, "convol2.pgm" );

	
	//3 - Binarize IMG global threshold 
		umbral( IMG, 40 );
			write_pnm( IMG, "2_threshold.pgm" );

	//4 - Opening / Erotion->Dilatation
		int Umbral = 13;
		//Opening
			//Erosion
			negate( IMG );
			chamfer34( IMG ); 
			umbral( IMG , Umbral );
			negate( IMG );
					write_pnm( IMG, "3_EROTION.pgm" );
			//Dilatation
			chamfer34( IMG );
			umbral( IMG , Umbral );
					write_pnm( IMG, "4_DILATATION.pgm" );
			cleanBorder( IMG , Umbral );
					write_pnm( IMG, "5_OPENING.pgm" );

	//5 - Extract triangles (Fill)
		printf("#Looking for objects... \n");
		int X,Y;
		int OBJcount = 0;
		int OBJ[5];
		int COLOR;
		
		//Look for objects to fill them
		while(1)
		{
			findOBJ(IMG, &X, &Y, 0);
			if(X > -1){ //Valid Point
				//printf("#Found object at: %d , %d \n", X,Y);
				COLOR = FILLTONE + OBJcount * CINC;
				
				push(X,Y);
				do_fill(IMG, OBJ , 0 , COLOR );	//Fill 0's with COLOR

				OBJcount+=1;
			}
			else break;
		}
		printf("# \t [%d] Objects found! \n", OBJcount);
		if(!OBJcount) return( -1 );

				write_pnm( IMG, "6_Segmentation.pgm" );		


	//Save each Scene vertex in a list
	POINT* PointS = malloc( sizeof(POINT) * 3 * OBJcount );
 
	//6 - Compute vertices of each triangle
		printf("# \n" );

		//Allocate memory enough for ANY perimeter segment
		POINT *perimeter = malloc( sizeof(POINT) * 2000 );
		//Allocate memory for each triangle vertices
		POINT* vertices = malloc( sizeof(POINT) * 3 );
		DPOINT* dv = malloc( sizeof(DPOINT) * 3 );

		for (int i = 0; i < OBJcount; ++i)
		{
			COLOR = FILLTONE + i * CINC;

			//a) Find first pixel of OBJColor
			findOBJ(IMG, &X, &Y, COLOR); //Find first vertex
			if(X > -1){ //Valid Point
				printf("\n\t ### Object [%d] ###\n\n",i+1);

				//Get Perimeter
				push(X,Y);
				do_fill(IMG, OBJ , COLOR , 1 );	//Fill COLOR's with 1's
						//write_pnm( IMG, "Fill.pgm" );		
				dilation_4neig_inplace_obj( IMG , OBJ, 1 );
						//write_pnm( IMG, "perimetroD.pgm" );		

				//Convert perimeter
				byte *pimg;
				for(int k=OBJ[INICIOY]; k<=OBJ[FINY]; k++ ) {
					pimg = (byte *)IMG->ptr[k] + OBJ[INICIOX];
					for(int p=OBJ[INICIOX]; p<=OBJ[FINX]; p++ ) {
						if ( *pimg == 254 ) {
							*pimg = 200;
						}
						pimg++;
					}
				}
				//write_pnm( IMG, "perimetroE.pgm" );		

		
				//printf("\n Size of POINT:: %d \n", sizeof(POINT) );
				
				int Counter = 0;

				follow_perimeter( IMG , Y, X , 200,    &Counter,   perimeter);
				//printf("#Counter: %d \n",Counter);
						write_pnm( IMG, "8_Perimeter.pgm" );		
				/*
				printf("\t OUTSIDE: Pixels of segment\n");
				for (int k = 0; k <= Counter ; k++)
				{
					printf(" %d,%d \t", perimeter[k].x, perimeter[k].y );
				}
				//*/

				//Extract triangles
				
				extrae_triangulo( perimeter , Counter , vertices, dv );
				
				//printf("#Triangle extracted...\n");

				printf("#\t     %d,%d \t %d,%d \t %d,%d \t#NEW\n", vertices[0].x , vertices[0].y,
																vertices[1].x , vertices[1].y,
																vertices[2].x , vertices[2].y);

				printf("#\t %.02f,%.02f \t %.02f,%.02f \t %.02f,%.02f \t#FLOAT\n", dv[0].x , dv[0].y,
																dv[1].x , dv[1].y,
																dv[2].x , dv[2].y);
										write_pnm( IMG, "10_FINAL.pgm" );		

				//Save vertices in list
				PointS[ 3*i ].x = dv[0].x;		PointS[ 3*i ].y = dv[0].y;  
				PointS[3*i+1].x = dv[1].x;		PointS[3*i+1].y = dv[1].y;
				PointS[3*i+2].x = dv[2].x;		PointS[3*i+2].y = dv[2].y;

			}
		}

		printf("\n\n#\t Scene [P] Vertex List:\n");
		for (int i = 0; i < OBJcount; ++i)
		{
			printf("#\t %.02f,%.02f \t %.02f,%.02f \t %.02f,%.02f \t\t #TRI:%d \n", PointS[ 3*i ].x , PointS[ 3*i ].y,
																				 PointS[3*i+1].x , PointS[3*i+1].y,
																				 PointS[3*i+2].x , PointS[3*i+2].y, i+1);
				
		}

		//Inverting y's of points 
		//for (int i = 0; i < 6; ++i)
		//{
		//	PointS[i].y = 480 - PointS[i].y;
		//}

		printf("\n#\t INVERTED Scene [P] Vertex List:\n");
		for (int i = 0; i < OBJcount; ++i)
		{
			printf("#\t %.02f,%.02f \t %.02f,%.02f \t %.02f,%.02f \t\t #TRI:%d \n", PointS[ 3*i ].x , PointS[ 3*i ].y,
																				 PointS[3*i+1].x , PointS[3*i+1].y,
																				 PointS[3*i+2].x , PointS[3*i+2].y, i+1);
				
		}




		//Copy points to structure
		printf("\n\n#\t Saving points to SCENE \n");
		
		T1[0] = PointS[0];
		T1[1] = PointS[1];
		T1[2] = PointS[2];

		T2[0] = PointS[3];
		T2[1] = PointS[4];
		T2[2] = PointS[5];
		


		free(vertices); free(dv);
		free(perimeter);
		free(PointS);


	//7 - Output points

	//if ( write_pnm( IMG, "fillTest1.pgm" ) != 0 )  
    //    return -1;

	matrix_free( IMG );
	//matrix_free( IN );
	matrix_free( FIL );

	return 0;
}
















// --------------------
// 
void drawPoint( MATRIX *IMG , int X, int Y , int R , int C) 
{
	byte *px;
	for (int i = Y-R; i < Y+R; i++)
	{	
		px = (byte *) IMG-> ptr[i];
		for (int j = X-R; j < X+R; j++){
			*px++ = C;
		}
	}
}



// --------------------
// Find first OBJ pixel in IMG
void findOBJ( const MATRIX *IMG , int* X, int* Y , int COLOR) 
{
	byte *px;
	for (int i = 0; i < IMG-> rows; i++)
	{	
		px = (byte *) IMG-> ptr[i];
		for (int j = 0; j < IMG-> cols; j++){
			if((*px) == COLOR){
				//printf("[%d,%d]= %d  ",i,j,*px);
				*Y=i;
				*X=j;
				return;
			}
			px++;
		}
	}
	*Y=	*X= -1; //No OBJ found!
}







